<form [formGroup]="shippingForm" #f="ngForm" (ngSubmit)="onSubmit(f.value)">
  <h2>Shipping</h2>
  <mat-form-field appearance="standard">
    <mat-label>Name</mat-label>
    <input matInput placeholder="name" formControlName="name" />
    <mat-error *ngIf="shippingForm.get('name').hasError('required')">
      Name is <strong>required</strong>
    </mat-error>
  </mat-form-field>

  <mat-form-field appearance="standard">
    <mat-label>Address</mat-label>
    <input matInput placeholder="line 1" formControlName="addressLine1" />
    <mat-error *ngIf="shippingForm.get('addressLine1').hasError('required')">
      Address is <strong>required</strong>
    </mat-error>
  </mat-form-field>

  <mat-form-field appearance="standard">
    <mat-label>Address</mat-label>
    <input matInput placeholder="line 2" formControlName="addressLine2" />
    <mat-error *ngIf="shippingForm.get('addressLine2').hasError('required')">
      Address is <strong>required</strong>
    </mat-error>
  </mat-form-field>

  <mat-form-field appearance="standard">
    <mat-label>City</mat-label>
    <input matInput placeholder="city" formControlName="city" />
    <mat-error *ngIf="shippingForm.get('city').hasError('required')">
      City is <strong>required</strong>
    </mat-error>
  </mat-form-field>
  <div class="button">
    <button [disabled]="!shippingForm.valid" type="submit" class="save-button" mat-raised-button color="primary">
      Place Order
    </button>
  </div>
</form>
